classification
Title: srcdir != builddir builds fail, if hg is not installed
Type: behavior Stage: resolved
Components: Build Versions: Python 3.4, Python 3.2, Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: rosslagerwall Nosy List: Arfrever, doko, ezio.melotti, ned.deily, python-dev, r.david.murray, rosslagerwall, rpetrov, trent
Priority: normal Keywords: needs review, patch

Created on 2012-10-17 09:01 by doko, last changed 2012-10-29 19:08 by rosslagerwall. This issue is now closed.

Files
File name Uploaded Description Edit
asdlgen.diff doko, 2012-10-17 10:18
Messages (16)
msg173146 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-17 09:01
seen with the 3.3 branch and the trunk:

also, I think using python now unconditionally breaks the cross builds, so this should call PYTHON_FOR_BUILD, not python.

/bin/mkdir -p Include
hg: no-repository, python: found! cannot run ../Parser/asdl_c.py -h Include ../Parser/Python.asdl
/bin/mkdir -p Python
hg: no-repository, python: found! cannot run ../Parser/asdl_c.py -c Python ../Parser/Python.asdl
gcc -pthread -c -Wno-unused-result -DNDEBUG -g -fwrapv -O3 -Wall -Wstrict-prototypes -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security  -fprofile-generate -g -flto -fuse-linker-plugin -IObjects -IInclude -IPython -I. -IInclude -I../Include -D_FORTIFY_SOURCE=2   -DPy_BUILD_CORE -o Python/Python-ast.o Python/Python-ast.c
gcc: error: Python/Python-ast.c: No such file or directory
gcc: fatal error: no input files
compilation terminated.
make[3]: *** [Python/Python-ast.o] Error 4
msg173153 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-17 10:18
looking at the unused subprocess import in asdl_c.py, maybe some call-outs to svn/hg were made in the past?

the patch removes the check for hg for the asdl.[ch] builds, and sets ADSLGEN to a appropriate python interpreter if one is found.

fixes the build for src != build; the cross build wasn't affected, we can build with any python version.
msg173155 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-17 10:37
r71315 did remove the call-out to hg, so it looks safe to not check for hg in ASDLGEN.
msg173156 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-17 10:39
typo, r71375
msg173243 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2012-10-18 08:41
I think you mean b23ad0a6cf87 (see #12273).
msg173299 - (view) Author: Roumen Petrov (rpetrov) * Date: 2012-10-18 21:34
issue 15819 is still open ....
msg173485 - (view) Author: Roundup Robot (python-dev) Date: 2012-10-21 21:19
New changeset 03236a19eb87 by Matthias Klose in branch '3.2':
- Issue #16262: fix out-of-src-tree builds, if mercurial is not installed.
http://hg.python.org/cpython/rev/03236a19eb87

New changeset ea6de576d1c8 by Matthias Klose in branch '3.3':
- Issue #16262: fix out-of-src-tree builds, if mercurial is not installed.
http://hg.python.org/cpython/rev/ea6de576d1c8

New changeset 2a0c9472c89c by Matthias Klose in branch 'default':
- Issue #16262: fix out-of-src-tree builds, if mercurial is not installed.
http://hg.python.org/cpython/rev/2a0c9472c89c
msg173486 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-21 21:23
now checked in even without review, because it was broken on the branches too.
msg173489 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2012-10-21 21:59
This change appears to have broken the dmg builders:

  http://buildbot.python.org/all/builders/bolen-dmg-3.x/builds/19
  http://buildbot.python.org/all/builders/bolen-dmg-3.3/builds/17
msg173674 - (view) Author: Trent Nelson (trent) * (Python committer) Date: 2012-10-24 12:22
On Sun, Oct 21, 2012 at 02:59:37PM -0700, R. David Murray wrote:
> 
> R. David Murray added the comment:
> 
> This change appears to have broken the dmg builders:
> 
>   http://buildbot.python.org/all/builders/bolen-dmg-3.x/builds/19
>   http://buildbot.python.org/all/builders/bolen-dmg-3.3/builds/17

    Ah, relevant error:

creating Makefile
Traceback (most recent call last):
  File "/Users/db3l/buildarea.dmg/bolen-dmg-3.x/build/Parser/asdl_c.py", line 1254, in ?
    main(args[0])
  File "/Users/db3l/buildarea.dmg/bolen-dmg-3.x/build/Parser/asdl_c.py", line 1203, in main
    c = ChainOfVisitors(TypeDefVisitor(f),
  File "/Users/db3l/buildarea.dmg/bolen-dmg-3.x/build/Parser/asdl_c.py", line 87, in __init__
    self.identifiers = set()
NameError: global name 'set' is not defined
make: *** [Include/Python-ast.h] Error 1
Running make

    So, it's not that it broke the daily dmg builders per se, it's just
    that the version of Python being used to generate the ADSL on those
    boxes is old (and doesn't have set()).  I guess that means whatever
    Python version was picked up is <2.4?
msg173675 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2012-10-24 12:28
Ah, good point.  From what I understand, that's entirely possible on that machine.  Then the question becomes, do we want to support pre-2.4 for a rebuild?  The answer is almost certainly no, but that leaves the DMG builders hosed.

Re-closing issue, as this is arguably a problem with the DMG build machine.
msg173677 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-24 12:36
yes, the test checks with a recent version first, then the older ones. However you can configure with PYTHON=python2.4 configure ... to overwrite these defaults.
msg173679 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2012-10-24 13:06
Wait, does that mean you are explicitly supporting older Python versions?  In that case there's still a bug here (either fix the set, or don't accept versions older than 2.4).
msg173706 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2012-10-24 20:57
> Wait, does that mean you are explicitly supporting older Python versions? 

no, that is unchanged. the Parser/asdl_c.py script had a shebang with python. Of course you could replace the python in AC_CHECK_PROCS with the allowed python2.x versions. But then maybe rename it to ASDLGEN_PYTHON, or something like this
msg174002 - (view) Author: Arfrever Frehtes Taifersar Arahesis (Arfrever) * Date: 2012-10-28 07:29
The following syntax is broken:
if $PYTHON = not-found; then

...
checking for python3.4... python3.4
python3.4: can't open file '=': [Errno 2] No such file or directory
checking for a BSD-compatible install... /usr/bin/install -c
...

You probably want to use 'if test $PYTHON = not-found'.
msg174135 - (view) Author: Roundup Robot (python-dev) Date: 2012-10-29 17:42
New changeset c6787a4c544e by Ross Lagerwall in branch '3.2':
Fix regression from issue #16262
http://hg.python.org/cpython/rev/c6787a4c544e

New changeset b82a4f8a4c67 by Ross Lagerwall in branch '3.3':
Merge with 3.2 for issue #16262
http://hg.python.org/cpython/rev/b82a4f8a4c67

New changeset 1bee1a176306 by Ross Lagerwall in branch 'default':
Merge with 3.3 for issue #16262
http://hg.python.org/cpython/rev/1bee1a176306
History
Date User Action Args
2012-10-29 19:08:50rosslagerwallsetstatus: open -> closed

nosy: + rosslagerwall
versions: + Python 3.2, Python 3.4
assignee: rosslagerwall
resolution: fixed
stage: resolved
2012-10-29 17:42:37python-devsetmessages: + msg174135
2012-10-28 07:29:37Arfreversetstatus: closed -> open
resolution: fixed -> (no value)
messages: + msg174002
2012-10-24 20:57:07dokosetmessages: + msg173706
2012-10-24 13:37:33ned.deilysetnosy: + ned.deily
2012-10-24 13:06:45r.david.murraysetmessages: + msg173679
2012-10-24 12:36:03dokosetmessages: + msg173677
2012-10-24 12:28:07r.david.murraysetstatus: open -> closed

messages: + msg173675
2012-10-24 12:22:43trentsetmessages: + msg173674
2012-10-21 21:59:37r.david.murraysetstatus: closed -> open
nosy: + r.david.murray
messages: + msg173489

2012-10-21 21:23:11dokosetstatus: open -> closed
resolution: fixed
messages: + msg173486
2012-10-21 21:19:23python-devsetnosy: + python-dev
messages: + msg173485
2012-10-18 21:34:59rpetrovsetnosy: + rpetrov
messages: + msg173299
2012-10-18 08:41:41ezio.melottisettype: behavior

messages: + msg173243
nosy: + ezio.melotti
2012-10-17 20:16:48Arfreversetnosy: + Arfrever
2012-10-17 11:01:31pitrousetnosy: + trent
2012-10-17 10:40:36dokosetcomponents: + Build
versions: + Python 3.3
2012-10-17 10:39:02dokosetmessages: + msg173156
2012-10-17 10:37:28dokosetmessages: + msg173155
2012-10-17 10:18:57dokosetkeywords: + needs review, patch
files: + asdlgen.diff
messages: + msg173153
2012-10-17 09:01:26dokocreate